package com.merchantsofrome.server.controller

import com.merchantsofrome.server.model.*
import com.merchantsofrome.server.repository.*
import org.springframework.http.HttpStatus
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.*
import java.util.*
import kotlin.collections.ArrayList

@RestController
@RequestMapping("/api/mining")
class MineController(private val mineRepository: MineRepository, private val accountRepository: AccountRepository, private val oreRepository: OreRepository, private val itemRepository: ItemRepository, private val itemAccountRepository: ItemAccountRepository, private val oreAccountRepository: OreAccountRepository) {

    @GetMapping
    fun getAllMines() : List<Mine> = mineRepository.findAll()

    @PostMapping("/collectfrommine")
    fun collectFromMine(@RequestHeader(value = "Username") username: String,
                        @RequestBody mineIds: Array<Int>) : Any {

        // Finds the min amount, max amount and id for the ore
        /*var minAmountStone = 0
        var maxAmountStone = 0
        var stoneOreId = 0*/

        /*var minAmountClay = 0
        var maxAmountClay = 0
        var clayOreId = 0*/

        var minAmountIron = 0
        var maxAmountIron = 0
        var ironOreId = 0

        /*var minAmountCopper = 0
        var maxAmountCopper = 0
        var copperOreId = 0*/

        /*var minAmountSilver = 0
        var maxAmountSilver = 0
        var silverOreId = 0*/

        /*var minAmountGold = 0
        var maxAmountGold = 0
        var goldOreId = 0*/

        val allOres: List<Ore> = oreRepository.findAll()
        for (ore: Ore in allOres) {
            when (ore.oreName) {
                /*"stone" -> {
                    minAmountStone = ore.minAmountPerSec
                    maxAmountStone = ore.maxAmountPerSec
                    stoneOreId = ore.oreId
                }*/
                /*"clay" -> {
                    minAmountClay = ore.minAmountPerSec
                    maxAmountClay = ore.maxAmountPerSec
                    clayOreId = ore.oreId
                }*/
                "iron" -> {
                    minAmountIron = ore.minAmountPerSec
                    maxAmountIron = ore.maxAmountPerSec
                    ironOreId = ore.oreId
                }
                /*"copper" -> {
                    minAmountCopper = ore.minAmountPerSec
                    maxAmountCopper = ore.maxAmountPerSec
                    copperOreId = ore.oreId
                }*/
                /*"silver" -> {
                    minAmountSilver = ore.minAmountPerSec
                    maxAmountSilver = ore.maxAmountPerSec
                    silverOreId = ore.oreId
                }*/
                /*"gold" -> {
                    minAmountGold = ore.minAmountPerSec
                    maxAmountGold = ore.maxAmountPerSec
                    goldOreId = ore.oreId
                }*/
            }
        }



        // Goes through the mines collected and calculates how much is collected for one and one mine of each ore
        // var minedAmountStone = 0
        // var minedAmountClay = 0
        var minedAmountIron = 0
        // var minedAmountCopper = 0
        // var minedAmountSilver = 0
        // var minedAmountGold = 0

        val minesForAccount: List<Mine> = mineRepository.getMineByAccount_Username(username = username)
        for (mine: Mine in minesForAccount) {
            if (mineIds.contains(mine.mineId)) {
                val timeStartedMining: Long = mine.startTime.time
                val finishTime: Long = timeStartedMining + (mine.timeToMine * 1000)

                val stage = stage(timeLeft(Date(finishTime)), mine.timeToMine.toInt())
                if (stage > 0) {

                    val calendar: Calendar = Calendar.getInstance()
                    val now: Long = calendar.time.time

                    var secondsMined: Long = (now - timeStartedMining) / 1000
                    if (secondsMined > mine.timeToMine) {
                        secondsMined = mine.timeToMine
                    }

                    val random = Random()

                    /*val minAmountStoneForThisMine: Int = minAmountStone * secondsMined.toInt()
                    val maxAmountStoneForThisMine: Int = maxAmountStone * secondsMined.toInt()
                    minedAmountStone += (random.nextInt(maxAmountStoneForThisMine + 1 - minAmountStoneForThisMine) + minAmountStoneForThisMine) / 100*/

                    /*val minAmountClayForThisMine: Int = minAmountClay * secondsMined.toInt()
                    val maxAmountClayForThisMine: Int = maxAmountClay * secondsMined.toInt()
                    minedAmountClay += (random.nextInt(maxAmountClayForThisMine + 1 - minAmountClayForThisMine) + minAmountClayForThisMine) / 100*/

                    val minAmountIronForThisMine: Int = minAmountIron * secondsMined.toInt()
                    val maxAmountIronForThisMine: Int = maxAmountIron * secondsMined.toInt()
                    minedAmountIron += (random.nextInt(maxAmountIronForThisMine + 1 - minAmountIronForThisMine) + minAmountIronForThisMine) / 100

                    /*val minAmountCopperForThisMine: Int = minAmountCopper * secondsMined.toInt()
                    val maxAmountCopperForThisMine: Int = maxAmountCopper * secondsMined.toInt()
                    minedAmountCopper += (random.nextInt(maxAmountCopperForThisMine + 1 - minAmountCopperForThisMine) + minAmountCopperForThisMine) / 100*/

                    /*val minAmountSilverForThisMine: Int = minAmountSilver * secondsMined.toInt()
                    val maxAmountSilverForThisMine: Int = maxAmountSilver * secondsMined.toInt()
                    minedAmountSilver += (random.nextInt(maxAmountSilverForThisMine + 1 - minAmountSilverForThisMine) + minAmountSilverForThisMine) / 100*/

                    /*val minAmountGoldForThisMine: Int = minAmountGold * secondsMined.toInt()
                    val maxAmountGoldForThisMine: Int = maxAmountGold * secondsMined.toInt()
                    minedAmountGold += (random.nextInt(maxAmountGoldForThisMine + 1 - minAmountGoldForThisMine) + minAmountGoldForThisMine) / 100*/

                    val newMine = mine.copy(startTime = Date(), numberOfTimesMined = mine.numberOfTimesMined + 1)
                    mineRepository.save(newMine)
                } else {
                    return ResponseEntity<Any>(HttpStatus.BAD_REQUEST)
                }
            }
        }



        // Finds the OreAccount if it exists in the database, else it creates a new one
        // Creates a new instance of the OreAccount and saves the updated one in the database
        /*val oreAccountStone: OreAccount
        if (oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = stoneOreId) == null) {
            oreAccountStone = OreAccount(oreId = stoneOreId, account = accountRepository.findById(username).get(), totalAmountCollected = 0)
            oreAccountRepository.save(oreAccountStone)
        } else {
            oreAccountStone = oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = stoneOreId)!!
        }
        val newOreAccountStone: OreAccount = oreAccountStone.copy(totalAmountCollected = oreAccountStone.totalAmountCollected + minedAmountStone)
        oreAccountRepository.save(newOreAccountStone)*/

        /*val oreAccountClay: OreAccount
        if (oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = clayOreId) == null) {
            oreAccountClay = OreAccount(oreId = clayOreId, account = accountRepository.findById(username).get(), totalAmountCollected = 0)
            oreAccountRepository.save(oreAccountClay)
        } else {
            oreAccountClay = oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = clayOreId)!!
        }
        val newOreAccountClay: OreAccount = oreAccountClay.copy(totalAmountCollected = oreAccountClay.totalAmountCollected + minedAmountClay)
        oreAccountRepository.save(newOreAccountClay)*/

        val oreAccountIron: OreAccount
        if (oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = ironOreId) == null) {
            oreAccountIron = OreAccount(oreId = ironOreId, account = accountRepository.findById(username).get(), totalAmountCollected = 0)
            oreAccountRepository.save(oreAccountIron)
        } else {
            oreAccountIron = oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = ironOreId)!!
        }
        val newOreAccountIron: OreAccount = oreAccountIron.copy(totalAmountCollected = oreAccountIron.totalAmountCollected + minedAmountIron)
        oreAccountRepository.save(newOreAccountIron)

        /*val oreAccountCopper: OreAccount
        if (oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = copperOreId) == null) {
            oreAccountCopper = OreAccount(oreId = copperOreId, account = accountRepository.findById(username).get(), totalAmountCollected = 0)
            oreAccountRepository.save(oreAccountCopper)
        } else {
            oreAccountCopper = oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = copperOreId)!!
        }
        val newOreAccountCopper: OreAccount = oreAccountCopper.copy(totalAmountCollected = oreAccountCopper.totalAmountCollected + minedAmountCopper)
        oreAccountRepository.save(newOreAccountCopper)*/

        /*val oreAccountSilver: OreAccount
        if (oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = silverOreId) == null) {
            oreAccountSilver = OreAccount(oreId = silverOreId, account = accountRepository.findById(username).get(), totalAmountCollected = 0)
            oreAccountRepository.save(oreAccountSilver)
        } else {
            oreAccountSilver = oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = silverOreId)!!
        }
        val newOreAccountSilver: OreAccount = oreAccountSilver.copy(totalAmountCollected = oreAccountSilver.totalAmountCollected + minedAmountSilver)
        oreAccountRepository.save(newOreAccountSilver)*/

        /*val oreAccountGold: OreAccount
        if (oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = goldOreId) == null) {
            oreAccountGold = OreAccount(oreId = goldOreId, account = accountRepository.findById(username).get(), totalAmountCollected = 0)
            oreAccountRepository.save(oreAccountGold)
        } else {
            oreAccountGold = oreAccountRepository.getOreAccountByAccount_UsernameAndOreId(username = username, oreId = goldOreId)!!
        }
        val newOreAccountGold: OreAccount = oreAccountGold.copy(totalAmountCollected = oreAccountGold.totalAmountCollected + minedAmountGold)
        oreAccountRepository.save(newOreAccountGold)*/



        // Finds the ores' id in the item table
        // var stoneId = -1
        // var clayId = -1
        var ironId = -1
        // var copperId = -1
        // var silverId = -1
        // var goldId = -1

        val oreItems: List<Item> = itemRepository.getItemsByCategory(category = "ores")
        for (item: Item in oreItems) {
            when (item.name) {
                // "stone" -> stoneId = item.id
                // "clay" -> clayId = item.id
                "ironOre" -> ironId = item.id
                // "copperOre" -> copperId = item.id
                // "silverOre" -> silverId = item.id
                // "goldOre" -> goldId = item.id
            }
        }

        // Finds the ItemAccount if it exists in the database, else it creates a new one
        // Creates a new instance of the ItemAccount and saves the updated one in the database
        /*val itemAccountStone: ItemAccount
        if (itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = stoneId) == null) {
            itemAccountStone = ItemAccount(amountOwned = 0, itemId = stoneId, account = accountRepository.findById(username).get())
            itemAccountRepository.save(itemAccountStone)
        } else {
            itemAccountStone = itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = stoneId)!!
        }
        val newItemAccountStone: ItemAccount = itemAccountStone.copy(amountOwned = itemAccountStone.amountOwned + minedAmountStone)
        itemAccountRepository.save(newItemAccountStone)*/

        /*val itemAccountClay: ItemAccount
        if (itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = clayId) == null) {
            itemAccountClay = ItemAccount(amountOwned = 0, itemId = clayId, account = accountRepository.findById(username).get())
            itemAccountRepository.save(itemAccountClay)
        } else {
            itemAccountClay = itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = clayId)!!
        }
        val newItemAccountClay: ItemAccount = itemAccountClay.copy(amountOwned = itemAccountClay.amountOwned + minedAmountClay)
        itemAccountRepository.save(newItemAccountClay)*/

        val itemAccountIron: ItemAccount
        if (itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = ironId) == null) {
            itemAccountIron = ItemAccount(amountOwned = 0, itemId = ironId, account = accountRepository.findById(username).get())
            itemAccountRepository.save(itemAccountIron)
        } else {
            itemAccountIron = itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = ironId)!!
        }
        val newItemAccountIron: ItemAccount = itemAccountIron.copy(amountOwned = itemAccountIron.amountOwned + minedAmountIron)
        itemAccountRepository.save(newItemAccountIron)

        /*val itemAccountCopper: ItemAccount
        if (itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = copperId) == null) {
            itemAccountCopper = ItemAccount(amountOwned = 0, itemId = copperId, account = accountRepository.findById(username).get())
            itemAccountRepository.save(itemAccountCopper)
        } else {
            itemAccountCopper = itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = copperId)!!
        }
        val newItemAccountCopper: ItemAccount = itemAccountCopper.copy(amountOwned = itemAccountCopper.amountOwned + minedAmountCopper)
        itemAccountRepository.save(newItemAccountCopper)*/

        /*val itemAccountSilver: ItemAccount
        if (itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = silverId) == null) {
            itemAccountSilver = ItemAccount(amountOwned = 0, itemId = silverId, account = accountRepository.findById(username).get())
            itemAccountRepository.save(itemAccountSilver)
        } else {
            itemAccountSilver = itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = silverId)!!
        }
        val newItemAccountSilver: ItemAccount = itemAccountSilver.copy(amountOwned = itemAccountSilver.amountOwned + minedAmountSilver)
        itemAccountRepository.save(newItemAccountSilver)*/

        /*val itemAccountGold: ItemAccount
        if (itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = goldId) == null) {
            itemAccountGold = ItemAccount(amountOwned = 0, itemId = goldId, account = accountRepository.findById(username).get())
            itemAccountRepository.save(itemAccountGold)
        } else {
            itemAccountGold = itemAccountRepository.getItemAccountByAccount_UsernameAndItemId(username = username, itemId = goldId)!!
        }
        val newItemAccountGold: ItemAccount = itemAccountGold.copy(amountOwned = itemAccountGold.amountOwned + minedAmountGold)
        itemAccountRepository.save(newItemAccountGold)*/



        // Adds the number of mined ores to an array list and sends them to the frontend
        // HUSK INDEX'ENE I LISTEN
        val amountList: ArrayList<Int> = ArrayList()
        // amountList.add(index = 0, element = minedAmountStone)
        // amountList.add(index = 1, element = minedAmountClay)
        amountList.add(index = 0, element = minedAmountIron)
        // amountList.add(index = 3, element = minedAmountCopper)
        // amountList.add(index = 4, element = minedAmountSilver)
        // amountList.add(index = 5, element = minedAmountGold)

        return amountList
    }

    private fun stage(timeleft: Int, timeToMine: Int) : Int {
        return Math.min(3 - Math.ceil(timeleft / (timeToMine / 3.0)), 3.0).toInt()
    }

    private fun timeLeft(finishTime: Date) : Int {
        return Math.max(0, Math.round((finishTime.time - Date().time).toDouble() / 1000).toInt())
    }

    @PostMapping("/buymine")
    fun buyMine(@RequestHeader(value = "Username") username: String) : Any {

        val account: Account = accountRepository.findById(username).get()
        val numberOfMines: Int = account.indexOfLastMineUnlocked

        val price: Int = when (numberOfMines) {
            0 -> 10
            1 -> 500
            2 -> 5_000
            3 -> 50_000
            4 -> 500_000
            else -> return ResponseEntity<Any>(HttpStatus.CONFLICT)
        }

        // TODO: Sjekk om bruker har 5 gruver. Logikk ved bestikkelse av senator
        if (numberOfMines >= 5) {
            return ResponseEntity<Any>(HttpStatus.NOT_IMPLEMENTED)
        }

        val coins = account.coinsOwned

        if (coins >= price) {
            val updatedAccount: Account = account.copy(indexOfLastMineUnlocked = numberOfMines + 1, coinsOwned = coins - price)
            accountRepository.save(updatedAccount)

            var mine = Mine(mineId = numberOfMines, startTime = Date(), account = updatedAccount)

            val timeToMine: Long = mine.timeToMine
            val startTime: Date = mine.startTime
            var finishedTime: Long = startTime.time + (timeToMine * 1000)
            if (numberOfMines == 0) {
                finishedTime = startTime.time + (timeToMine * 500)
                mine = mine.copy(startTime = Date(startTime.time - (timeToMine * 500)))
            }
            mineRepository.save(mine)

            val list: ArrayList<Any> = ArrayList()
            list.add(index = 0, element = numberOfMines)
            list.add(index = 1, element = mine.timeToMine.toInt())
            list.add(index = 2, element = finishedTime)
            return list
        }
        return ResponseEntity<Any>(HttpStatus.CONFLICT)
    }

    @GetMapping("/getallminesatstart")
    fun getAllMinesAtStart(@RequestHeader("Username") username: String) : ArrayList<ArrayList<Any>> {
        val list: ArrayList<ArrayList<Any>> = ArrayList()

        val minesForAccount = mineRepository.getMineByAccount_Username(username = username)

        for (mine: Mine in minesForAccount) {
            val mineId: Int = mine.mineId
            val timeToMine: Long = mine.timeToMine
            val startTime = mine.startTime

            val finishedTime: Long = startTime.time + (timeToMine * 1000)

            val mineList: ArrayList<Any> = ArrayList()
            mineList.add(index = 0, element = mineId)
            mineList.add(index = 1, element = timeToMine.toInt())
            mineList.add(index = 2, element = finishedTime)
            list.add(element = mineList)
        }
        return list
    }
}