package com.merchantsofrome.server.controller

import com.merchantsofrome.server.model.Plant
import com.merchantsofrome.server.repository.*
import org.springframework.http.HttpStatus
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.*
import kotlin.collections.ArrayList

@RestController
@RequestMapping("/api/trees")
class TreeController(private val treeRepository: TreeRepository, private val treeAccountRepository: TreeAccountRepository,
                     private val itemRepository: ItemRepository) {

    @GetMapping("/harvested")
    fun getHarvestedFruits(@RequestHeader("Username") username: String): ResponseEntity<Any>{
        val harvested = HashMap<String, Int>().withDefault { 0 }
        treeAccountRepository.getTreeAccountsByAccount_Username(username).forEach {
            val fruit = treeRepository.getTreeByName(it.tree!!.name)!!
            harvested[itemRepository.findById(fruit.fruitId).get().name] = it.totalAmountFruitHarvested
        }
        return ResponseEntity(harvested, HttpStatus.OK)
    }
}