package com.merchantsofrome.server.model


import com.fasterxml.jackson.annotation.JsonBackReference
import com.merchantsofrome.server.model.id_class.FarmPlotPK
import javax.persistence.*

@Entity
@IdClass(FarmPlotPK::class)
@Table(name="Farmplot")
data class FarmPlot (

        @Id
        val slotnr: Int = -1,

        @Id
        @ManyToOne
        @JoinColumn(name = "fk_username", nullable = false)
        @JsonBackReference
        var account: Account?=null,

        val finishedGrowing: Long? = -1,

        @ManyToOne(fetch = FetchType.LAZY)
        @JoinColumn(name = "fk_plantname")
        var plant: Plant? = null
)
