package com.merchantsofrome.server.model

import com.fasterxml.jackson.annotation.JsonBackReference
import com.merchantsofrome.server.model.id_class.MinePK
import java.util.*
import javax.persistence.*

@Entity
@IdClass(MinePK::class)
@Table(name = "Mine")
data class Mine (

        @Id
        val mineId: Int = -1,

        @Id
        @ManyToOne
        @JoinColumn(name = "fk_username", nullable = false)
        @JsonBackReference
        var account: Account? = null,

        val timeToMine: Long = 3600 * 8,

        val startTime: Date = Date(),

        val numberOfTimesMined: Int = 0
)