package com.merchantsofrome.server.model


import com.fasterxml.jackson.annotation.JsonBackReference
import com.merchantsofrome.server.model.id_class.PlantAccountPK
import javax.persistence.*

@Entity(name = "PlantAccount")
@IdClass(PlantAccountPK::class)
data class PlantAccount(
        val unlocked : Boolean = false,
        val totalAmountHarvested:Int= 0,
        val numberOfTimesHarvested:Int=0,

        @Id
        val plantName: String = "",

        @Id
        @ManyToOne(fetch = FetchType.LAZY)
        @JsonBackReference
        val account: Account?=null
)