package com.merchantsofrome.server.model

import com.fasterxml.jackson.annotation.JsonBackReference
import com.merchantsofrome.server.model.id_class.ProcessAccountPK
import javax.persistence.ManyToOne
import javax.persistence.*


@Entity
@IdClass(ProcessAccountPK::class)
data class ProcessAccount(

        @Id
        val processId: Int = 0,

        @Id
        @ManyToOne(fetch = FetchType.LAZY)
        @JsonBackReference
        val account: Account?=null,

        val finishTime:Long=0,

        val active: Boolean=true,

        val amount : Int=0,

        val totalAmountCollected: Int = 0,

        val numberOfTimesCollected: Int=0
)