package com.merchantsofrome.server.model


import com.fasterxml.jackson.annotation.JsonBackReference
import com.merchantsofrome.server.model.id_class.TreeAccountPK
import javax.persistence.*

@Entity(name = "TreeAccount")
@IdClass(TreeAccountPK::class)
data class TreeAccount(
        val totalAmountHarvested:Int= 0,
        val numberOfTimesHarvested:Int=0,

        val totalAmountFruitHarvested:Int= 0,
        val numberOfTimesFruitHarvested:Int=0,

        @Id
        @ManyToOne(fetch = FetchType.LAZY)
        val tree: Tree? = null,

        @Id
        @ManyToOne(fetch = FetchType.LAZY)
        @JsonBackReference
        val account: Account?=null
)