package com.merchantsofrome.server.model


import com.fasterxml.jackson.annotation.JsonBackReference
import com.merchantsofrome.server.model.id_class.TreePatchPK
import javax.persistence.*

@Entity
@IdClass(TreePatchPK::class)
@Table(name="TreePatch")
data class TreePatch (

        @Id
        val slotnr: Int = -1,

        @Id
        @ManyToOne
        @JoinColumn(name = "fk_username", nullable = false)
        @JsonBackReference
        var account: Account?=null,

        val finishedGrowing: Long? = -1,
        val finishedGrowingFruit: Long? = -1,

        @ManyToOne(fetch = FetchType.LAZY)
        @JoinColumn(name = "fk_treename")
        var tree: Tree? = null
)
