package com.merchantsofrome.server.repository

import com.merchantsofrome.server.model.Feedback
import com.merchantsofrome.server.model.Item
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.stereotype.Repository

@Repository
interface FeedbackRepository : JpaRepository<Feedback,Int> {
    fun getFeedbacksByUsername(username: String): List<Feedback>

    fun getFeedbacksByQuestionId(questionId: Int): List<Feedback>

    fun getFeedbacksByFortuneGreaterThan(minFortune: Int): List<Feedback>

    fun getFeedbackByUsernameAndQuestionId(username: String, questionId: Int): List<Feedback>
}