package com.merchantsofrome.server.repository

import com.merchantsofrome.server.model.PlantAccount
import com.merchantsofrome.server.model.id_class.PlantAccountPK
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.stereotype.Repository

@Repository
interface PlantAccountRepository : JpaRepository<PlantAccount, PlantAccountPK>{

    fun getPlantAccountByAccount_UsernameAndUnlockedEquals(username:String, Unlocked:Boolean):ArrayList<PlantAccount>

    fun getPlantAccountByAccount_UsernameAndPlantName(username: String, plantName:String):PlantAccount?

    fun getPlantAccountsByAccount_Username(username: String): ArrayList<PlantAccount>
}