package com.merchantsofrome.server.repository

import com.merchantsofrome.server.model.id_class.ProcessAccountPK
import com.merchantsofrome.server.model.ProcessAccount
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.stereotype.Repository

@Repository
interface ProcessAccountRepository : JpaRepository<ProcessAccount, ProcessAccountPK> {

    fun getAllByAccount_Username(username:String):List<ProcessAccount>

    fun getByAccount_UsernameAndActive(username:String, active: Boolean): List<ProcessAccount>

    fun getByAccount_UsernameAndProcessId(username:String, processId:Int):ProcessAccount?
}