package com.merchantsofrome.server.repository

import com.merchantsofrome.server.model.Version
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Modifying
import org.springframework.data.jpa.repository.Query
import org.springframework.data.repository.query.Param
import org.springframework.stereotype.Repository
import org.springframework.transaction.annotation.Transactional

@Repository
interface VersionRepository : JpaRepository<Version, Int>{

    fun getById(id:Int):Version?

    @Transactional
    @Modifying
    @Query("UPDATE Version v SET v.version = :version WHERE v.id = 0")
    fun updateVersion(@Param("version") version:Int)
}