import React, { Component } from 'react';
import './ItemBox.css';
import {Strings} from './utils'
import {Item} from "./Items/Item";

interface IItemBoxState{
    imgLoaded: boolean;
}

interface IItemBoxProps{
    item: Item,
    sell: (item: Item) => void,
    style?: {}
}

export class ItemBox extends Component<IItemBoxProps,IItemBoxState>{
    state = {
        imgLoaded: false
    };

    constructor(props: IItemBoxProps) {
        super(props);
        this.sell = this.sell.bind(this);
    }

    componentDidMount() {
    }

    sell() {
        this.props.sell(this.props.item);
    }

    render() {
        return (
            <div className="item-box" style={this.state.imgLoaded ? (this.props.style?this.props.style:{}) : {display: 'none'}} onClick={this.sell}>
                <span className="item-box-name"> {Strings.decamelize(this.props.item.name)}</span>
                <img className="item-box-img"
                     src={this.props.item.imageUrl()}
                     alt={Strings.decamelize(this.props.item.name)}
                     onLoad={()=>this.setState({imgLoaded: true})}
                />
                <span className="item-box-amount">{this.props.item.amount.toLocaleString()}</span>
            </div>
        )
    }
}