import {Category, Tab} from "../Enum";

export abstract class Item{
    name: string;
    amount: number;
    category: string;

    protected constructor(name: string, category: string, amount:number = 0) {
        this.name = name;
        this.category = category;
        this.amount = amount;
    }

    imageUrl() {
        return `images/${this.name}.png`
    }

    abstract displayInTab(tab: Tab): boolean
}
