import {Tab, ActionType} from "../Enum";
import {Item} from "../Items/Item";
import {Plant} from "../farming/Plant";
import {FeedbackQuestion, InventoryList, PriceList, Process} from "../utils";
import {Mine} from "../mining/Mine";
import {Ore} from "../Items/Ore";
import {Tree} from "../woodcutting/Tree";

//currentTab
export function setTab(tab: Tab) {
    return { type: ActionType.SET_TAB, tab: tab }
}

//inventory
export function setInventory(item: Item){
    return {type: ActionType.SET_INVENTORY, item: item}
}

export function increaseInventory(item: Item){
    return {type: ActionType.INCREASE_INVENTORY, item: item}
}

export function loadInventory(inventory: InventoryList){
    return {type: ActionType.LOAD_INVENTORY, inventory}
}

//unlockedSeeds
export function setUnlockedSeeds(unlockedSeeds: Plant[]){
    return {type: ActionType.SET_UNLOCKED_SEEDS, unlockedSeeds: unlockedSeeds}
}

export function unlockSeed(seed: Plant){
    return {type: ActionType.UNLOCK_SEED, seed: seed}
}

//farmPlots
export function plantSeeds(plants: Plant[]){
    return {type: ActionType.PLANT_SEEDS, plants: plants}
}

export function harvestSeeds(plants: Plant[]){
    return {type: ActionType.HARVEST_SEEDS, plants: plants}
}

export function uprootSeed(plotId: number){
    return {type: ActionType.UPROOT_SEED, plotId}
}

// mining
export function collectOre(mines: Mine[]) {
    return {type: ActionType.COLLECT_ORE, mines: mines}
}

export function newMine(mines: Mine[]) {
    return {type: ActionType.NEW_MINE, mines: mines}
}

export function unlockOre(ore: Ore) {
    return {type: ActionType.UNLOCK_ORE, ore: ore}
}

//woodcutting
export  function plantTrees(trees: Tree[]) {
    return {type:ActionType.PLANT_TREE, trees}
}

export  function chopTree(patches: number[]) {
    return {type:ActionType.CHOP_TREE, patches}
}

export  function harvestFruit(patches: number[]) {
    return {type:ActionType.HARVEST_FRUIT, patches}
}



//currentQuests
export function setQuest(questId: number, checkpointReached: number){
    return {type: ActionType.SET_QUEST, questId, checkpointReached}
}
export function addQuest(questId: number){
    return {type: ActionType.ADD_QUEST, questId: questId}
}

export function progressQuest(questId: number){
    return {type: ActionType.PROGRESS_QUEST, questId: questId}
}

export function completeQuest(questId: number){
    return {type: ActionType.COMPLETE_QUEST, questId: questId}
}

//processing
export function setProcess(category: string, name: string, time: number, amount: number, finishTime?: Date){
    return {type: ActionType.SET_PROCESS, category, name, time, amount, finishTime}
}

export function removeProcess(name: string){
    return {type: ActionType.REMOVE_PROCESS, name}
}

//prices
export function setPrice(name: string, price: number){
    return {type: ActionType.SET_PRICE, name, price}
}

export function loadPrices(priceList: PriceList){
    return {type: ActionType.LOAD_PRICES, priceList}
}


// login
export function logOut() {
    return {type: ActionType.LOG_OUT}
}

export function logIn() {
    return {type: ActionType.LOG_IN}
}

//history
export function loadHistory(category: string, history: History) {
    return {type: ActionType.LOAD_HISTORY, category, history}
}

export function addHistoryData(category: string, name: string, amount: number) {
    return {type: ActionType.ADD_HISTORY_DATA, category, name, amount}
}

//feedback
export function loadFeedbackQuestions(questions: FeedbackQuestion[]){
    return {type: ActionType.LOAD_FEEDBACK_QUESTIONS, questions}
}

export function answerFeedbackQuestion(){
    return {type: ActionType.ANSWER_FEEDBACK_QUESTION}
}