import React, { Component } from 'react';
import './DialogueTextInput.css';
import Button from "./Button";
import DialogueFooter from "./DialogueFooter";

interface IDialogueTextInputState{
    value: string
}

interface IDialogueTextInputProps{
    onClick: (value: string)=>void
    onChange: (value: string)=>void
    maxCharacters: number
}

class DialogueTextInput extends Component<IDialogueTextInputProps,IDialogueTextInputState>{


    constructor(props: IDialogueTextInputProps) {
        super(props);
        this.onChange = this.onChange.bind(this);
        this.state = {
            value: ""
        };
    }

    componentDidMount() {
    }

    onChange(event: any){
        let value = event.target.value;
        this.props.onChange(value);
        this.setState({
            value: ""+value
        });
    }

    render() {
        return (
            <div className="dialogue-text-input">
                {this.props.children}
                <div className="dialogue-text-input-div">
                    <textarea
                        className="dialogue-text-input-input"
                        value={this.state.value}
                        onChange={this.onChange}
                        maxLength={this.props.maxCharacters}
                     />
                     <span className="dialogue-text-input-count">
                         {this.state.value.length}/{this.props.maxCharacters}
                     </span>
                </div>
                <DialogueFooter>
                    <div className="dialogue-text-input-buttons">
                        <Button onClick={()=>{
                            this.setState({value: ""});
                            this.props.onClick(this.state.value)
                        }} text={"Submit"}/>
                    </div>
                </DialogueFooter>
            </div>
        )
    }
}

export default DialogueTextInput;
