export class Mine{
    mineId: number;
    timeToMine: number;
    finishTime: Date;
    stages: number;

    constructor(mineId: number = -1, timeToMine: number, stages: number, finishTime?: number) {
        this.mineId = mineId;
        this.timeToMine = timeToMine;
        this.stages = stages;
        if (finishTime) {
            this.finishTime = new Date(finishTime);
        } else {
            let finishDate = new Date();
            finishDate.setSeconds(finishDate.getSeconds() + this.timeToMine);
            this.finishTime = finishDate;
        }
    }

    imageUrl(time: number = 0) {
        return `images/mining/mining${this.stage(time)}.png`
    }

    stage(time: number) {
        return Math.max(0, Math.min(this.stages - Math.ceil(time / (this.timeToMine / (this.stages))), this.stages));
    }

    timeLeft() {
        return Math.max(0, Math.round((this.finishTime.getTime() - new Date().getTime()) / 1000));
    }
}