import {Component} from "react";
import {DialogueStandards} from "../dialogue/DialogueStandards";
import React from "react";
import {connect} from "react-redux";
import {completeQuest, progressQuest} from "../actions/actions";

interface IFirstFarmProps{
    questProgression: number,
    progressQuest: (questId: number) => void,
    completeQuest: (questId: number) => void,
}

interface IFirstFarmState{
}

const questId = 0;

const mapStateToProps = (state: any) => {
    return {
        questProgression: state.currentQuest[questId]
    }
};

const mapDispatchToProps = (dispatch: any) => {
    return {
        progressQuest: (questId: number) => dispatch(progressQuest(questId)),
        completeQuest: (questId: number) => dispatch(completeQuest(questId)),
    }
};


class ConnectedFirstFarm extends Component<IFirstFarmProps,IFirstFarmState>{
    state = {
    };

    constructor(props: IFirstFarmProps) {
        super(props);
    }

    dialogues: JSX.Element[] = [
        DialogueStandards.CONFIRM_DIALOGUE(
            "Welcome!",
            `Dear slave, welcome to the free world!`,
            ()=>{this.props.progressQuest(questId)}
        ),
        DialogueStandards.CONFIRM_DIALOGUE(
            "Welcome!",
            "lmao",
            ()=>{}
        )
    ];

    show(): JSX.Element{
        return this.dialogues[this.props.questProgression]
    }

    render() {
        return (
            <div className="quest">
                {this.show()}
            </div>

        )
    }
}

const FirstFarm = connect(mapStateToProps, mapDispatchToProps)(ConnectedFirstFarm);

export default FirstFarm;
