import {QuestLine} from "./QuestLine";
import {IQuestData, IQuestTools, QuestFactory} from "./Quest";
import {QuestTest} from "./quest-lines/Test";
import {ReduxState} from "../reducers/reducer";
import {IQuestBase, QuestBase} from "./QuestBase";
import {Quest1} from "./quest-lines/Quest1";
import {Quest3} from "./quest-lines/Quest3";
import {Quest2} from "./quest-lines/Quest2";
import {Quest4} from "./quest-lines/Quest4";
import {Quest5} from "./quest-lines/Quest5";

export class QuestDatabase{
    private static list: IQuestBase[] = [
        QuestTest,
        Quest1,
        Quest2,
        Quest3,
        Quest4,
        Quest5
        ];

    static getElement(index: number, data: IQuestData, tools: IQuestTools){
        return QuestFactory.create(wrap(this.list[index])(data, tools).get());
    }

    static getTitle(index: number){
        return this.list[index].questTitle;
    }
}

function wrap(className: IQuestBase){
    return (data: IQuestData, tools: IQuestTools) => new className(data,tools)
}