import {QuestLine} from "../QuestLine";
import React from "react";
import {QuestBase} from "../QuestBase";
import {IQuestData, IQuestTools} from "../Quest";
import {ItemsName} from "../../Items/Items";
import {OreName} from "../../Items/Ore";
import {MetalName} from "../../Items/Metal";

export class Quest2 extends QuestBase {
    static questTitle = "Quest 2";
    static coinsAmount = 10;
    constructor(state: IQuestData, tools: IQuestTools) {
        super(state, tools)
    }

    get = () => new QuestLine(2)
        .addCheckpointElementBody(Quest2.questTitle,
            <div>
                <p>You need {Quest2.coinsAmount} coins {QuestBase.image("coins")} to buy yourself a mine.</p>
            </div>, () => this.checkItem(ItemsName.coins, Quest2.coinsAmount) || this.state.mines.length > 0, () => {})
        .addCheckpointElementBody(Quest2.questTitle,
            <div>
                <p>Buy a mine.</p>
            </div>, () => {return this.state.mines.length > 0})
        .addCheckpointElementBody(Quest2.questTitle,
            <div>
                <p>Congratulations with your first mine!</p>
                <p>Workers have started working in your mine and gathering iron ore {QuestBase.image("ironOre")}</p>
            </div>)
        .addCheckpointElementBody(Quest2.questTitle,
            <div>
                <p>Please collect the ores from the mine.</p>
                <p>Note that you can't collect ores again until the workers </p>
                <p>have been mining for at least 2:40:00 </p>
            </div>, () => this.checkItem(OreName.iron))
        .addCheckpointElementBody(Quest2.questTitle,
            <div>
                <p>Now, take the iron ore to the foundry {QuestBase.image("foundry")}. </p>
                <p className={"quest-warning-span"}>You will usually get one iron bar from 50 iron ore, but since you don't own your own foundry, the foundry worker takes half of your iron ore.</p>
                <p>Now we just have to wait until the foundry is finished.</p>
            </div>, () => this.checkItem(MetalName.iron))
        .addCheckpointElementBody(Quest2.questTitle,
            <div>
                <p>Take the iron to the forge {QuestBase.image("forge")} and tell the smith to make a sword {QuestBase.image("sword")} </p>
                <p className={"quest-warning-span"}>You will usually get one sword from 2 iron bars, but since you don't own your own forge, the smith takes half of your iron bars.</p> <br/> <br/>
                <p>Now we just have to wait until the smith is finished.</p>
            </div>, () => this.checkItem(MetalName.sword))
        .addCheckpointElementBody(Quest2.questTitle,
            <div>
                <p>Now, sell the sword {QuestBase.image("sword")} to the villagers {QuestBase.image("sellInventory")}</p>
            </div>, () => this.checkItem(ItemsName.coins) && !this.checkItem(MetalName.sword, 1))
        .addFinal(Quest2.questTitle, "Now, lets continue on to the next quest!", () => true, () => this.tools.addQuest(3));
}