import {QuestLine} from "../QuestLine";
import React from "react";
import {QuestBase} from "../QuestBase";
import {IQuestData, IQuestTools} from "../Quest";
import {ItemsName} from "../../Items/Items";
import {FruitName} from "../../Items/Fruit";
import {TreeName} from "../../woodcutting/Tree";
import {WoodName} from "../../Items/Wood";

export class Quest3 extends QuestBase {
    static questTitle = "Quest 3";
    static coinsAmount = 125;
    constructor(state: IQuestData, tools: IQuestTools) {
        super(state, tools)
    }

    get = () => new QuestLine(3)
        .addCheckpointElementBody(Quest3.questTitle,
            <div>
                <p>You need {Quest3.coinsAmount} coins {QuestBase.image("coins")} to buy yourself a tree patch </p>
                <p>From the tree you will be able to chop logs {QuestBase.image("logs")} and collect fruits {QuestBase.image("apple")} </p>
            </div>, () => {return this.checkItem(ItemsName.coins, Quest3.coinsAmount) || this.state.treePatches.length > 0})
        .addCheckpointElementBody(Quest3.questTitle,
            <div>
                <p>Buy a tree patch.</p>
            </div>, () => {return this.state.treePatches.length > 0})
        .addCheckpointElementBody(Quest3.questTitle,
            <div>
                <p>Congratulations with your first tree patch! </p>
                <p>To be able to plant something in your tree patch, you will normally have to buy some fruits from the fruit seller. </p>
                <p>But to get you started, I want to give you 1 apple {QuestBase.image("apple")} for free </p>
            </div>, () => true,()=>this.addItem("apple",1))
        .addCheckpointElementBody(Quest3.questTitle,
            <div>
                <p>Now plant the tree.</p>
            </div>, () => {return this.state.treePatches.filter((a) => a.name == TreeName.appleTree).length > 0})
        .addDialogueElementBody(Quest3.questTitle,
            <div>
                <p>So we just have to wait until the tree is finished growing.</p>
                <p className={"quest-warning-span"}>Don't chop down the tree before you have been able to collect some apples from the tree</p>
                <p>Apples will start growing after the tree is fully grown.</p>
            </div>)
        .addCheckpointElementBody(Quest3.questTitle,
            <div>
                <p>Now, please chop down some logs {QuestBase.image("logs")} and collect some apples {QuestBase.image("apple")}</p>
            </div>, () => {return this.checkItem(WoodName.logs) && this.checkItemTotal("trees", FruitName.apple)})
        .addCheckpointElementBody(Quest3.questTitle,
            <div>
                <p>Send the logs {QuestBase.image("logs")} to the sawmill {QuestBase.image("woodWorker")}.</p>
                <p className={"quest-warning-span"}>You will usually get 4 wood planks from one log, but since you don't own your own sawmill, the worker takes half of your wood planks.</p> <br/> <br/>
                <p>Then we just have to wait until the worker is finished.</p>
            </div>, () => {return this.checkItem(WoodName.planks)})
        /*.addCheckpointElementBody(Quest3.questTitle,
            <div>
                Now, send iron to the forge {QuestBase.image("forge")} and tell the smith to make nails {QuestBase.image("nails")}. <br/> <br/>
                <span className={"quest-warning-span"}>You will usually get 10 nails from 1 iron bar, but since you don't own your own forge, the smith takes half of your iron bars.</span> <br/> <br/>
                Now we just have to wait until the smith is finished.
            </div>, () => true) /!*this.checkItem("nails")*!/
        .addCheckpointElementBody(Quest3.questTitleq,
            <div>
                You need 150 wood planks {QuestBase.image("woodPlanks")} and 300 nails {QuestBase.image("nails")} to build yourself a boat {QuestBase.image("boat")}.
            </div>, () => true) /!*this.checkItem("woodPlanks", 150) && this.checkItem("nails", 300)*!/
        .addCheckpointElementBody(Quest3.questTitle,
            <div>
                Now, give the wood planks {QuestBase.image("woodPlanks")} and the nails {QuestBase.image("nails")} to the boat builder {QuestBase.image("boatBuilder")}. <br/> <br/>
                Then we just have to wait until the boat builder is finished.
            </div>, () => true) /!*this.checkItem("boat")*!/
        .addCheckpointElementBody(Quest3.questTitle,
            <div>
                Congratulations! You have now got your first boat {QuestBase.image("boat")}. <br/> <br/>
                With this boat you can send some workers out to start fishing later on.
            </div>)*/
        .addFinal(Quest3.questTitle, "Now, lets continue on to the next quest!", () => true);
}