import {QuestLine} from "../QuestLine";
import React from "react";
import {QuestBase} from "../QuestBase";
import {IQuestData, IQuestTools} from "../Quest";



export class Quest5 extends QuestBase {
    static questTitle = "Quest 5";
    constructor(state: IQuestData, tools: IQuestTools) {
        super(state, tools)
    }

    get = () => new QuestLine(5)
        .addCheckpointElementBody(Quest5.questTitle,
            <div>
                You need x amount of iron {QuestBase.image("iron")} to make fishing
                hooks {QuestBase.image("fishingHooks")}. <br/> <br/>
                With these fishing hooks you can start fishing.
            </div> /*, () => {Sjekk om bruker har nok jern}*/)
        .addCheckpointElementBody(Quest5.questTitle,
            <div>
                Collect the iron ore {QuestBase.image("ironOre")}.
            </div> /*, () => {Sjekk om bruker har hentet jernmalmen}*/)
        .addCheckpointElementBody(Quest5.questTitle,
            <div>
                Send the iron ore {QuestBase.image("ironOre")} to the ironworker <img
                className={"quest-image"} src={"#"} alt={"ironworker"}/>. <br/> <br/>
                <span className={"quest-warning-span"}>Note that you will loose half of the iron ore.</span>
            </div> /*, () => {Sjekk om det er sendt til jernvinna. Halver antallet}*/)
        .addDialogue(Quest5.questTitle, "Now we just have to wait until the ironworker is finished." /*, () => {Gå videre når jernvinna er ferdig}*/)
        .addCheckpointElementBody(Quest5.questTitle,
            <div>
                Send the iron {QuestBase.image("iron")} to the smith and tell him to make
                fishing hooks {QuestBase.image("fishingooks")}. <br/> <br/>
                <span className={"quest-warning-span"}>Note that you will loose half of the iron.</span>
            </div> /*, () => {Sjekk om det er sendt til smeden. Halver antallet}*/)
        .addDialogue(Quest5.questTitle, "Now we just have to wait until the smith is finished." /*, () => {Gå videre når smeden er ferdig}*/)
        .addCheckpointElementBody(Quest5.questTitle,
            <div>
                Send the workers out to start fishing {QuestBase.image("fishing")}.
            </div> /*, () => {Sjekk at fisking har startet}*/)
        .addDialogue(Quest5.questTitle, "Now we just have to wait until the fisher men are finished." /*, () => {Gå videre når fiskerne er ferdig}*/)
        .addCheckpointElementBody(Quest5.questTitle,
            <div>
                Congratulations! You have now got your first fish {QuestBase.image("fish")} <br/>
                These fish can be sold to generate more money.
            </div> /*, () => {Sjekk om bruker har fått fisker}*/)
        .addFinalElementBody(Quest5.questTitle,
            <div>
                You have now completed the first five quests. <br/>
                Hopefully you now have a better understanding how the free world works. <br/> <br/>
                Now you will have to survive on your own.
            </div> /*, Avslutt quest-ene*/);
}