import {QuestLine} from "../QuestLine";
import React from "react";
import {IQuestData, IQuestTools} from "../Quest";
import {Ore, OreName} from "../../Items/Ore";
import {Item} from "../../Items/Item";
import {Crop, CropName} from "../../Items/Crops";
import {QuestBase} from "../QuestBase";

export class QuestTest extends QuestBase{
    static questTitle = "Testing quest";
    constructor(state: IQuestData, tools: IQuestTools){
        super(state, tools)
    }
    get = () => new QuestLine(0)
        .addDialogue("Welcome","Hello there slave, welcome to the free world!")
        .addCheckpoint("Welcome", "This is more text")
        .addCheckpointElementBody("Wheat",
            <div>
                Please get me 5000 wheat
                {QuestBase.image("wheat")}
            </div>,
            ()=>this.checkItem(CropName.wheat,5000),
            ()=>{
                this.addItem(OreName.silver, 100);
                this.removeItem(CropName.wheat, 5000);
            }
        )
        .addDialogue("lol", "just a bit of talking")
        .addCheckpoint("save", "please bring me a bag of flour")
        .addFinal("last one", "this is the end");
}

