import {Plant} from "../farming/Plant";
import {ActionType} from "../Enum";
import {CropName} from "../Items/Crops";

export function farmPlots(state: Plant[] = [], action: any){
    if(action.type === ActionType.PLANT_SEEDS){
        return replacePlants(state, action.plants);
    }
    if(action.type === ActionType.HARVEST_SEEDS){
        let plants: Plant[] = [];
        for(let i in action.plants){
            plants.push(new Plant(CropName.empty,action.plants[i].plotId))
        }
        //console.log(state, plants, action.plants);
        return replacePlants(state, plants);
    }
    if(action.type === ActionType.UPROOT_SEED){
        return replacePlants(state, [new Plant(CropName.empty,action.plotId)])
    }
    return state;
}

function replacePlants(state: Plant[], newPlants: Plant[]){
    let newState: Plant[] = state.slice(0);
    //debugger;
    for(let i = 0; i < newPlants.length; i++){
        let replaced: boolean = false;
        for(let j = 0; j < state.length; j++){
            let a = newPlants[i]?newPlants[i].plotId:-1;
            if(a == state[j].plotId){
                newState[j] = newPlants[i];
                replaced = true;
                break;
            }
        }
        if(!replaced){
            newState.push(newPlants[i]);
        }
    }
    return newState;
}