import {InventoryList, ItemFactory} from "../utils";
import {ActionType} from "../Enum";

export function inventory(state: InventoryList = new InventoryList(), action: any){
    if(action.type === ActionType.LOAD_INVENTORY){
        return Object.assign(new InventoryList(), state, action.inventory)
    }
    if(action.type === ActionType.SET_INVENTORY){
        let inv = Object.assign(new InventoryList(),state);
        inv[action.item.name] = action.item;
        return inv;
    }
    if(action.type === ActionType.INCREASE_INVENTORY){
        let inv = Object.assign(new InventoryList(),state);
        let prevAmount = state[action.item.name]?state[action.item.name].amount:0;
        let totalAmount = prevAmount + action.item.amount;
        inv[action.item.name] = ItemFactory.create(action.item.name, totalAmount, action.item.category);
        return inv;
    }

    return state;
}