import {Action, combineReducers} from "redux";
import {inventory} from "./inventory";
import {unlockedSeeds} from "./unlockedSeeds";
import {currentTab} from "./currentTab";
import {farmPlots} from "./farmPlots";
import {currentQuests} from "./currentQuests";
import {Plant} from "../farming/Plant";
import {ActionType, Tab} from "../Enum";
import {FeedbackInfo, HistoryMap, InventoryList, PriceList, ProcessList, QuestList} from "../utils";
import {Mine} from "../mining/Mine";
import {mines} from "./mines";
import {processing} from "./processing";
import {prices} from "./prices";
import {loggedIn} from "./loggedIn";
import {treePatches} from "./treePatches";
import {Tree} from "../woodcutting/Tree";
import {history} from "./history";
import {feedback} from "./feedback";

const rootReducer = (state:any, action:any) => {
    if (action.type === ActionType.LOG_OUT) {
        state = undefined
    }
    return gameReducer(state, action)
};

const gameReducer = combineReducers({
    inventory, // : InventoryList
    unlockedSeeds, // : Plant[]
    currentTab, // : Tab
    farmPlots, // : Plant[]
    currentQuests, // : QuestList
    mines, // : Mine[]
    processing, // : ProcessList
    prices, // : PriceList
    loggedIn,  // : boolean
    treePatches, // : Tree[]
    history, // : HistoryMap
    feedback, // : FeedbackInfo
});

export interface ReduxState{
    inventory: InventoryList
    unlockedSeeds: Plant[]
    currentTab: Tab
    farmPlots: Plant[]
    currentQuests: QuestList
    mines: Mine[]
    processing: ProcessList
    prices: PriceList
    loggedIn: boolean
    treePatches: Tree[]
    history: HistoryMap
    feedback: FeedbackInfo
}

export default rootReducer;