import {Tree, TreeName} from "../woodcutting/Tree";
import {ActionType} from "../Enum";
import {CropName} from "../Items/Crops";

export function treePatches(state: Tree[] = [], action: any){
    if(action.type === ActionType.PLANT_TREE){
        return replaceTrees(state, action.trees);
    }
    if(action.type === ActionType.CHOP_TREE){
        let trees: Tree[] = [];
        for(let i in action.patches){
            trees.push(new Tree(TreeName.empty,action.patches[i]))
        }
        //console.log(state, plants, action.plants);
        return replaceTrees(state, trees);
    }
    if(action.type === ActionType.HARVEST_FRUIT){
        let trees: Tree[] = [];
        for(let i in action.patches){
            let oldTree: Tree = state[action.patches[i]];
            let fruitFinishTime = new Date();
            fruitFinishTime.setSeconds(fruitFinishTime.getSeconds()+oldTree.timeToGrowFruit);
            let newTree = new Tree(oldTree.name, oldTree.patchId, oldTree.finishTime, fruitFinishTime);
            trees.push(newTree);
        }
        return replaceTrees(state, trees);
    }
    return state;
}

function replaceTrees(state: Tree[], newTrees: Tree[]){
    let newState: Tree[] = state.slice(0);
    //debugger;
    for(let i = 0; i < newTrees.length; i++){
        let replaced: boolean = false;
        for(let j = 0; j < state.length; j++){
            let a = newTrees[i]?newTrees[i].patchId:-1;
            if(a == state[j].patchId){
                newState[j] = newTrees[i];
                replaced = true;
                break;
            }
        }
        if(!replaced){
            newState.push(newTrees[i]);
        }
    }
    return newState;
}