import React, {Component} from 'react';
import './ScoreboardEntry.css';
import {DialogueTools, Fetch, Strings} from '../utils'
import {Item} from "../Items/Item";
import {ScoreboardTabData} from "./Scoreboard";

interface IScoreboardEntryState {
}

interface IScoreboardEntryProps {
    username: string,
    score: number,
    index: number,
}

export class ScoreboardEntry extends Component<IScoreboardEntryProps, IScoreboardEntryState> {
    state = {
    };

    constructor(props: IScoreboardEntryProps) {
        super(props);
    }

    componentDidMount() {
    }

    placementClass(){
        switch(this.props.index){
            case 0: return "first";
            case 1: return "second";
            case 2: return "third";
            default: return "";
        }
    }

    placementImage(){
        if(this.props.index < 3){
            return this.img("trophy"+(Number(this.props.index)+1))
        }else{
            return <span className={"scoreboard-entry-image"}>{this.props.index+1}</span>
        }
    }

    img = DialogueTools.imageFunction("scoreboard-entry");

    render() {
        return (
            <div className={`scoreboard-entry ${this.placementClass()}`}>
                {this.placementImage()}
                <div className={"scoreboard-username"}>
                    {this.props.username}
                </div>
                <div className={"scoreboard-score"}>
                    <div className="scoreboard-score-text">{this.props.score.toLocaleString()}</div>
                </div>
            </div>
        )
    }
}