import React, { Component } from "react";
import Game from "../Game";
import {Tab} from "../Enum";
import {Fetch} from "../utils";
import "./ChangePasswordPage.css";
import Button from "../dialogue/Button";

interface IChangePasswordPageProps {
    currentTab: Tab
}

interface IChangePasswordPageState {
    goBack: boolean;
    oldPassword: string;
    newPassword: string;
    confirmPassword: string;
    hiddenText: string;
}

class ChangePasswordPage extends Component<IChangePasswordPageProps, IChangePasswordPageState> {

    state = {
        goBack: false,
        oldPassword: "",
        newPassword: "",
        confirmPassword: "",
        hiddenText: ""
    };

    constructor(props: IChangePasswordPageProps) {
        super(props);
        this.backToGameClick = this.backToGameClick.bind(this);
        this.oldPasswordChange = this.oldPasswordChange.bind(this);
        this.newPasswordChange = this.newPasswordChange.bind(this);
        this.confirmPasswordChange = this.confirmPasswordChange.bind(this);
        this.changePasswordClick = this.changePasswordClick.bind(this);
    }

    backToGameClick() {
        this.setState({
            goBack: true
        })
    }

    oldPasswordChange(event: any) {
        let password = event.target.value;
        this.setState({
            oldPassword: password
        });
    }

    newPasswordChange(event: any) {
        let password = event.target.value;
        this.setState({
            newPassword: password
        });
    }

    confirmPasswordChange(event: any) {
        let password = event.target.value;
        this.setState({
            confirmPassword: password
        });
    }

    changePasswordClick(event: any) {
        let oldPassword = this.state.oldPassword;
        let newPassword = this.state.newPassword;
        let confirmPassword = this.state.confirmPassword;

        if (oldPassword != null && oldPassword != "" && newPassword != null && newPassword != "" && confirmPassword != null && confirmPassword != "") {
            if (newPassword === confirmPassword) {

                // TODO: Hent brukernavn fra session
                let username = "a";
                // TODO: Hash passordene
                Fetch.put("/api/accounts/changepassword/" + username, [oldPassword, newPassword]).then(response => {
                    if (response.status === 200) {
                        this.setState({
                            hiddenText: "The password has changed"
                        });
                        setInterval(() => this.setState({
                            goBack: true
                        }), 2000);
                    } else {
                        this.setState({
                            hiddenText: response.status + " " + response.statusText
                        });
                    }
                });
            } else {
                this.setState({
                    oldPassword: "",
                    newPassword: "",
                    confirmPassword: "",
                    hiddenText: "Passwords don't match"
                });
            }
        } else {
            this.setState({
                oldPassword: "",
                newPassword: "",
                confirmPassword: "",
                hiddenText: "You must write values for username, password and confirm password"
            });
        }
        event.preventDefault();
    }

    render() {
        const changePasswordPage = (
            <div className={"change-password-page"}>
                <h2 id={"change-password-page-text"}>Change password</h2>
                <form id={"change-password-page-form"}>
                    <input id={"old-password-input-change-password-page"} value={this.state.oldPassword} type={"password"} onChange={this.oldPasswordChange} placeholder="Old password"/> <br/>
                    <input id={"new-password-input-change-password-page"} value={this.state.newPassword} type={"password"} onChange={this.newPasswordChange} placeholder={"New password"}/> <br/>
                    <input id={"confirm-password-input-change-password-page"} value={this.state.confirmPassword} type={"password"} onChange={this.confirmPasswordChange} placeholder={"Confirm password"}/> <br/>
                    <span id={"hidden-info-text-change-password-page"}>{this.state.hiddenText}</span> <br/>
                    <Button text={"Change password"} onClick={() => this.changePasswordClick(event)}/>
                </form>
                <Button text={"Back"} onClick={() => this.backToGameClick()}/>
            </div>
        );

        return (
            this.state.goBack ? <Game /> : changePasswordPage
        )
    }
}

export default ChangePasswordPage;