import React, { Component } from 'react';

import './FruitSeed.css'
import {Tree} from "./Tree";
import {Fruit} from "../Items/Fruit";

interface IFruitSeedProps {
    fruit: Fruit;
    plantFruitSeeds: (fruit: Fruit)=>void;
}

interface IFruitSeedState {
}


export class FruitSeed extends Component<IFruitSeedProps,IFruitSeedState> {
    state = {
    };

    constructor(props: IFruitSeedProps) {
        super(props);
        this.click = this.click.bind(this);
    }

    componentDidMount() {
    }

    click(){
        this.props.plantFruitSeeds(this.props.fruit)
    }

    componentWillUnmount() {
    }

    render() {
        return (
            <div className="fruit-seed" onClick={this.click}>
                <img src={this.props.fruit.imageUrl()} alt={this.props.fruit.name}/>
                <span className={"fruit-seed-amount"}>{this.props.fruit.amount}</span>
            </div>
        )
    }
}

